/* -*-C++-*-
 * ###################################################################
 *  Cpptcl - connecting C++ with Tcl
 * 
 *  FILE: "Econobj.h"
 *                                    created: 15/10/97 {11:12:56 am} 
 *                                last update: 1/4/98 {7:06:23 am} 
 *  Author: Vince Darley
 *  E-mail: <darley@fas.harvard.edu>
 *    mail: Division of Engineering and Applied Sciences, Harvard University
 *          Oxford Street, Cambridge MA 02138, USA
 *     www: <http://www.fas.harvard.edu/~darley/>
 *  
 * ========================================================================
 *               Copyright (c) 1997 Vince Darley
 * ========================================================================
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose and without fee is hereby granted,
 * provided that the above copyright notice appear in all copies and that
 * both that the copyright notice and warranty disclaimer appear in
 * supporting documentation.
 * 
 * Vince Darley disclaims all warranties with regard to this software,
 * including all implied warranties of merchantability and fitness.  In
 * no event shall Vince Darley be liable for any special, indirect or
 * consequential damages or any damages whatsoever resulting from loss of
 * use, data or profits, whether in an action of contract, negligence or
 * other tortuous action, arising out of or in connection with the use or
 * performance of this software.
 * ========================================================================
 *  Description: 
 * 
 *  History
 * 
 *  modified by  rev reason
 *  -------- --- --- -----------
 *  15/10/97 VMD 1.0 original
 * ###################################################################
 */

#ifndef _Cpptcl_Econobj_
#define _Cpptcl_Econobj_

#include "cpptcl.h"

class Econobj: public tcl_object {
  public:
	Econobj(tcl_args& arg);
	~Econobj(void){}
	int parse_tcl_command(tcl_args& arg);
	Cpptcl_Class(Econobj);

  public:
	double lambda;
	double sigma;
	double rho;
	double b;
	double B;
	double beta;
	double C;
	long T;
	int predictor;
  private:
};

#endif
